/**
 * @name eslint-plugin-row-num
 * @fileoverview ESLint plugin to update row numbers on each console.log
 * @version 3.0.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/eslint-plugin-row-num/}
 */
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
// src/main.ts
var main_exports = {};
__export(main_exports, {
  default: () => main_default
});
// ../string-collapse-leading-whitespace/dist/string-collapse-leading-whitespace.esm.js
function D(l, u2 = 1) {
  let $2 = "\xA0";
  function g2(e) {
    return Array.from(e).reverse().join("");
  }
  function a(e, t, o) {
    let r = o ? `
` : "\r", i = o ? "\r" : `
`;
    if (!e)
      return e;
    let p2 = 0, c2 = 0, s = "";
    for (let n = 0, f2 = e.length; n < f2; n++)
      (e[n] === r || e[n] === i && e[n - 1] !== r) && c2++, `\r
`.includes(e[n]) || e[n] === $2 ? (p2 = 0, e[n] === $2 ? s += e[n] : e[n] === r ? c2 <= t && (s += e[n], e[n + 1] === i && (s += e[n + 1], n++)) : e[n] === i && e?.[n - 1] !== r && c2 <= t && (s += e[n])) : (p2++, !e[n + 1] && !c2 && (s += " "));
    return s;
  }
  if (typeof l == "string" && l.length) {
    let e = 1;
    typeof +u2 == "number" && Number.isInteger(+u2) && +u2 >= 0 && (e = +u2);
    let t = "", o = "";
    if (!l.trim())
      t = l;
    else if (!l[0].trim()) {
      for (let r = 0, i = l.length; r < i; r++)
        if (l[r].trim()) {
          t = l.slice(0, r);
          break;
        }
    }
    if (l.trim() && (l.slice(-1).trim() === "" || l.slice(-1) === $2)) {
      for (let r = l.length; r--; )
        if (l[r].trim()) {
          o = l.slice(r + 1);
          break;
        }
    }
    return `${a(t, e, false)}${l.trim()}${g2(a(g2(o), e, true))}`;
  }
  return l;
}
// ../ranges-push/dist/ranges-push.esm.js
var b = { strictlyTwoElementsInRangeArrays: false, progressFn: null };
function h(i, r) {
  if (!Array.isArray(i) || !i.length)
    return i;
  let t = { ...b, ...r }, e, l;
  if (t.strictlyTwoElementsInRangeArrays && !i.every((o, g2) => !Array.isArray(o) || o.length !== 2 ? (e = g2, l = o.length, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${e}th range (${JSON.stringify(i[e], null, 4)}) has not two but ${l} elements!`);
  if (!i.every((o, g2) => !Array.isArray(o) || !Number.isInteger(o[0]) || o[0] < 0 || !Number.isInteger(o[1]) || o[1] < 0 ? (e = g2, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${e}th range (${JSON.stringify(i[e], null, 4)}) does not consist of only natural numbers!`);
  let n = i.length ** 2, a = 0;
  return Array.from(i).sort((o, g2) => (t.progressFn && (a += 1, t.progressFn(Math.floor(a * 100 / n))), o[0] === g2[0] ? o[1] < g2[1] ? -1 : o[1] > g2[1] ? 1 : 0 : o[0] < g2[0] ? -1 : 1));
}
var c = { mergeType: 1, progressFn: null, joinRangesThatTouchEdges: true };
function f(i, r) {
  function t(s) {
    return !!s && typeof s == "object" && !Array.isArray(s);
  }
  if (!Array.isArray(i) || !i.length)
    return null;
  let e;
  if (r)
    if (t(r)) {
      if (e = { ...c, ...r }, e.progressFn && t(e.progressFn) && !Object.keys(e.progressFn).length)
        e.progressFn = null;
      else if (e.progressFn && typeof e.progressFn != "function")
        throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof e.progressFn}", equal to ${JSON.stringify(e.progressFn, null, 4)}`);
      if (![1, 2, "1", "2"].includes(e.mergeType))
        throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof e.mergeType}", equal to ${JSON.stringify(e.mergeType, null, 4)}`);
      if (typeof e.joinRangesThatTouchEdges != "boolean")
        throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof e.joinRangesThatTouchEdges}", equal to ${JSON.stringify(e.joinRangesThatTouchEdges, null, 4)}`);
    } else
      throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r, null, 4)} (type ${typeof r})`);
  else
    e = { ...c };
  let l = i.filter((s) => Array.isArray(s)).map((s) => [...s]).filter((s) => s[2] !== void 0 || s[0] !== s[1]), n, a, o;
  e.progressFn ? n = h(l, { progressFn: (s) => {
    o = Math.floor(s / 5), o !== a && (a = o, e.progressFn(o));
  } }) : n = h(l);
  let g2 = n.length - 1;
  for (let s = g2; s > 0; s--)
    e.progressFn && (o = Math.floor((1 - s / g2) * 78) + 21, o !== a && o > a && (a = o, e.progressFn(o))), (n[s][0] <= n[s - 1][0] || !e.joinRangesThatTouchEdges && n[s][0] < n[s - 1][1] || e.joinRangesThatTouchEdges && n[s][0] <= n[s - 1][1]) && (n[s - 1][0] = Math.min(n[s][0], n[s - 1][0]), n[s - 1][1] = Math.max(n[s][1], n[s - 1][1]), n[s][2] !== void 0 && (n[s - 1][0] >= n[s][0] || n[s - 1][1] <= n[s][1]) && n[s - 1][2] !== null && (n[s][2] === null && n[s - 1][2] !== null ? n[s - 1][2] = null : n[s - 1][2] != null ? +e.mergeType == 2 && n[s - 1][0] === n[s][0] ? n[s - 1][2] = n[s][2] : n[s - 1][2] += n[s][2] : n[s - 1][2] = n[s][2]), n.splice(s, 1), s = n.length);
  return n.length ? n : null;
}
function u(i) {
  return i != null;
}
function p(i) {
  return Number.isInteger(i) && i >= 0;
}
function m(i) {
  return typeof i == "string";
}
var T = { limitToBeAddedWhitespace: false, limitLinebreaksCount: 1, mergeType: 1 };
var $ = class {
  constructor(r) {
    let t = { ...T, ...r };
    if (t.mergeType && t.mergeType !== 1 && t.mergeType !== 2)
      if (m(t.mergeType) && t.mergeType.trim() === "1")
        t.mergeType = 1;
      else if (m(t.mergeType) && t.mergeType.trim() === "2")
        t.mergeType = 2;
      else
        throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof t.mergeType}", equal to ${JSON.stringify(t.mergeType, null, 4)}`);
    this.opts = t, this.ranges = [];
  }
  ranges;
  opts;
  add(r, t, e) {
    if (r == null && t == null)
      return;
    if (u(r) && !u(t)) {
      if (Array.isArray(r)) {
        if (r.length) {
          if (r.some((a) => Array.isArray(a))) {
            r.forEach((a) => {
              Array.isArray(a) && this.add(...a);
            });
            return;
          }
          r.length && p(+r[0]) && p(+r[1]) && this.add(...r);
        }
        return;
      }
      throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(r, null, 0)}) but second-one, "to" is not (${JSON.stringify(t, null, 0)})`);
    } else if (!u(r) && u(t))
      throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(t, null, 0)}) but first-one, "from" is not (${JSON.stringify(r, null, 0)})`);
    let l = +r, n = +t;
    if (p(e) && (e = String(e)), p(l) && p(n)) {
      if (u(e) && !m(e) && !p(e))
        throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof e}, equal to:
${JSON.stringify(e, null, 4)}`);
      if (u(this.ranges) && Array.isArray(this.last()) && l === this.last()[1]) {
        if (this.last()[1] = n, this.last()[2], this.last()[2] !== null && u(e)) {
          let a = this.last()[2] && this.last()[2].length && (!this.opts?.mergeType || this.opts.mergeType === 1) ? `${this.last()[2]}${e}` : e;
          this.opts.limitToBeAddedWhitespace && (a = D(a, this.opts.limitLinebreaksCount)), m(a) && !a.length || (this.last()[2] = a);
        }
      } else {
        this.ranges || (this.ranges = []);
        let a = e !== void 0 && !(m(e) && !e.length) ? [l, n, e && this.opts.limitToBeAddedWhitespace ? D(e, this.opts.limitLinebreaksCount) : e] : [l, n];
        this.ranges.push(a);
      }
    } else
      throw p(l) && l >= 0 ? new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof n}" equal to: ${JSON.stringify(n, null, 4)}`) : new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof l}" equal to: ${JSON.stringify(l, null, 4)}`);
  }
  push(r, t, e) {
    this.add(r, t, e);
  }
  current() {
    return Array.isArray(this.ranges) && this.ranges.length ? (this.ranges = f(this.ranges, { mergeType: this.opts.mergeType }), this.ranges && this.opts.limitToBeAddedWhitespace ? this.ranges.map((r) => u(r[2]) ? [r[0], r[1], D(r[2], this.opts.limitLinebreaksCount)] : r) : this.ranges) : null;
  }
  wipe() {
    this.ranges = [];
  }
  replace(r) {
    if (Array.isArray(r) && r.length)
      if (Array.isArray(r[0]) && p(r[0][0]))
        this.ranges = Array.from(r);
      else
        throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(r[0], null, 4)} should be an array and its first element should be an integer, a string index.`);
    else
      this.ranges = [];
  }
  last() {
    return Array.isArray(this.ranges) && this.ranges.length ? this.ranges[this.ranges.length - 1] : null;
  }
};
// ../ranges-sort/dist/ranges-sort.esm.js
var d = { strictlyTwoElementsInRangeArrays: false, progressFn: null };
function g(t, l) {
  if (!Array.isArray(t) || !t.length)
    return t;
  let n = { ...d, ...l }, s, o;
  if (n.strictlyTwoElementsInRangeArrays && !t.every((e, r) => !Array.isArray(e) || e.length !== 2 ? (s = r, o = e.length, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${s}th range (${JSON.stringify(t[s], null, 4)}) has not two but ${o} elements!`);
  if (!t.every((e, r) => !Array.isArray(e) || !Number.isInteger(e[0]) || e[0] < 0 || !Number.isInteger(e[1]) || e[1] < 0 ? (s = r, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${s}th range (${JSON.stringify(t[s], null, 4)}) does not consist of only natural numbers!`);
  let a = t.length ** 2, i = 0;
  return Array.from(t).sort((e, r) => (n.progressFn && (i += 1, n.progressFn(Math.floor(i * 100 / a))), e[0] === r[0] ? e[1] < r[1] ? -1 : e[1] > r[1] ? 1 : 0 : e[0] < r[0] ? -1 : 1));
}
// ../ranges-merge/dist/ranges-merge.esm.js
var d2 = { mergeType: 1, progressFn: null, joinRangesThatTouchEdges: true };
function b2(i, t) {
  function a(e) {
    return !!e && typeof e == "object" && !Array.isArray(e);
  }
  if (!Array.isArray(i) || !i.length)
    return null;
  let n;
  if (t)
    if (a(t)) {
      if (n = { ...d2, ...t }, n.progressFn && a(n.progressFn) && !Object.keys(n.progressFn).length)
        n.progressFn = null;
      else if (n.progressFn && typeof n.progressFn != "function")
        throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof n.progressFn}", equal to ${JSON.stringify(n.progressFn, null, 4)}`);
      if (![1, 2, "1", "2"].includes(n.mergeType))
        throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType, null, 4)}`);
      if (typeof n.joinRangesThatTouchEdges != "boolean")
        throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof n.joinRangesThatTouchEdges}", equal to ${JSON.stringify(n.joinRangesThatTouchEdges, null, 4)}`);
    } else
      throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(t, null, 4)} (type ${typeof t})`);
  else
    n = { ...d2 };
  let l = i.filter((e) => Array.isArray(e)).map((e) => [...e]).filter((e) => e[2] !== void 0 || e[0] !== e[1]), s, o, r;
  n.progressFn ? s = g(l, { progressFn: (e) => {
    r = Math.floor(e / 5), r !== o && (o = r, n.progressFn(r));
  } }) : s = g(l);
  let g2 = s.length - 1;
  for (let e = g2; e > 0; e--)
    n.progressFn && (r = Math.floor((1 - e / g2) * 78) + 21, r !== o && r > o && (o = r, n.progressFn(r))), (s[e][0] <= s[e - 1][0] || !n.joinRangesThatTouchEdges && s[e][0] < s[e - 1][1] || n.joinRangesThatTouchEdges && s[e][0] <= s[e - 1][1]) && (s[e - 1][0] = Math.min(s[e][0], s[e - 1][0]), s[e - 1][1] = Math.max(s[e][1], s[e - 1][1]), s[e][2] !== void 0 && (s[e - 1][0] >= s[e][0] || s[e - 1][1] <= s[e][1]) && s[e - 1][2] !== null && (s[e][2] === null && s[e - 1][2] !== null ? s[e - 1][2] = null : s[e - 1][2] != null ? +n.mergeType == 2 && s[e - 1][0] === s[e][0] ? s[e - 1][2] = s[e][2] : s[e - 1][2] += s[e][2] : s[e - 1][2] = s[e][2]), s.splice(e, 1), e = s.length);
  return s.length ? s : null;
}
// ../../node_modules/tiny-invariant/dist/esm/tiny-invariant.js
var isProduction = process.env.NODE_ENV === "production";
var prefix = "Invariant failed";
function invariant(condition, message) {
  if (condition) {
    return;
  }
  if (isProduction) {
    throw new Error(prefix);
  }
  var provided = typeof message === "function" ? message() : message;
  var value = provided ? "".concat(prefix, ": ").concat(provided) : prefix;
  throw new Error(value);
}
// ../ranges-apply/dist/ranges-apply.esm.js
function v(s, r, n) {
  let t = 0, o = 0;
  if (arguments.length === 0)
    throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");
  if (typeof s != "string")
    throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof s}, equal to: ${JSON.stringify(s, null, 4)}`);
  if (r && !Array.isArray(r))
    throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof r}, equal to: ${JSON.stringify(r, null, 4)}`);
  if (n && typeof n != "function")
    throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n, null, 4)}`);
  if (!r || !r.filter((e) => e).length)
    return s;
  let a;
  Array.isArray(r) && Number.isInteger(r[0]) && Number.isInteger(r[1]) ? a = [Array.from(r)] : a = Array.from(r);
  let d3 = a.length, c2 = 0;
  a.filter((e) => e).forEach((e, i) => {
    if (n && (t = Math.floor(c2 / d3 * 10), t !== o && (o = t, n(t))), !Array.isArray(e))
      throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${i}th element not an array: ${JSON.stringify(e, null, 4)}, which is ${typeof e}`);
    if (!Number.isInteger(e[0])) {
      if (!Number.isInteger(+e[0]) || +e[0] < 0)
        throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${i}th element, array ${JSON.stringify(e, null, 0)}. Its first element is not an integer, string index, but ${typeof e[0]}, equal to: ${JSON.stringify(e[0], null, 4)}.`);
      a[i][0] = +a[i][0];
    }
    if (!Number.isInteger(e[1])) {
      if (!Number.isInteger(+e[1]) || +e[1] < 0)
        throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${i}th element, array ${JSON.stringify(e, null, 0)}. Its second element is not an integer, string index, but ${typeof e[1]}, equal to: ${JSON.stringify(e[1], null, 4)}.`);
      a[i][1] = +a[i][1];
    }
    c2 += 1;
  });
  let l = b2(a, { progressFn: (e) => {
    n && (t = 10 + Math.floor(e / 10), t !== o && (o = t, n(t)));
  } });
  invariant(l);
  let y = l.length;
  if (y > 0) {
    let e = s.slice(l[y - 1][1]);
    s = l.reduce((i, $2, p2, u2) => {
      n && (t = 20 + Math.floor(p2 / y * 80), t !== o && (o = t, n(t)));
      let g2 = p2 === 0 ? 0 : u2[p2 - 1][1], m2 = u2[p2][0];
      return `${i}${s.slice(g2, m2)}${u2[p2][2] || ""}`;
    }, ""), s += e;
  }
  return s;
}
// ../js-row-num/dist/js-row-num.esm.js
var v2 = { padStart: 3, overrideRowNum: null, triggerKeywords: ["console.log"], extractedLogContentsWereGiven: false };
function j(t, S) {
  let p2 = Date.now(), f2 = "\\";
  if (typeof t != "string")
    throw new TypeError(`js-row-num: [THROW_ID_01] Input must be string! Currently it's: ${(typeof t).toLowerCase()}, equal to:
${JSON.stringify(t, null, 4)}`);
  if (!t.trim())
    return { log: { timeTakenInMilliseconds: Date.now() - p2 }, result: t, ranges: null };
  function a(n) {
    return /[0-9]/.test(n);
  }
  function y(n) {
    return /[A-Za-z]/.test(n);
  }
  function D2(n) {
    return !!n && typeof n == "object" && !Array.isArray(n);
  }
  let o = { ...v2, ...S };
  if (Object.prototype.hasOwnProperty.call(o, "returnRangesOnly"))
    throw new TypeError(`js-row-num: [THROW_ID_02] The Optional Options Object's key "returnRangesOnly" has been removed from the API since v.6 release.`);
  (!o.padStart || typeof o.padStart != "number" || typeof o.padStart == "number" && o.padStart < 0) && (o.padStart = 0);
  let g2 = new $(), e, d3 = t.length, r = null, u2 = null, m2 = null, c2 = 1, $2 = false, s = null;
  for (o.padStart && d3 > 45e3 && (o.padStart = 4), e = 0; e < d3; e++) {
    if (o.overrideRowNum === null && (t[e] === `
` || t[e] === "\r" && t[e + 1] !== `
`) && (c2 += 1), !o.extractedLogContentsWereGiven && r !== null && r.start < e && r.type === t[e] && (r = null, u2 = null, m2 = null, s = null, $2 = false), r === null && (o.extractedLogContentsWereGiven || u2 && u2 < e && m2 && m2 < e) && t[e].trim())
      if (t[e] === '"' || t[e] === "'" || t[e] === "`")
        r = { start: e, type: t[e] }, $2 = false;
      else if (o.extractedLogContentsWereGiven && s === null)
        if (a(t[e]))
          s = e;
        else
          break;
      else
        t[e].trim() && t[e] !== "/" && !o.extractedLogContentsWereGiven && (u2 = null, m2 = null, s = null);
    if (r && Number.isInteger(r.start) && r.start < e && !$2 && s === null && a(t[e]) && (s = e), Number.isInteger(s) && (!a(t[e]) || !t[e + 1]) && (e > s || !t[e + 1]) && (o.padStart || o.overrideRowNum != null, g2.push(s, a(t[e]) ? e + 1 : e, o.padStart ? String(o.overrideRowNum != null ? o.overrideRowNum : c2).padStart(o.padStart, "0") : `${o.overrideRowNum != null ? o.overrideRowNum : c2}`), s = null, $2 = true), r && Number.isInteger(r.start) && r.start < e && !$2 && y(t[e]) && !(t[e] === "n" && t[e - 1] === f2)) {
      if (t[e - 1] === f2 && t[e] === "u" && t[e + 1] === "0" && t[e + 2] === "0" && t[e + 3] === "1" && (t[e + 4] === "b" || t[e + 5] === "B") && t[e + 5] === "[") {
        let n;
        a(t[e + 6]) ? n = e + 6 : t[e + 6] === "$" && t[e + 7] === "{" && a(t[e + 8]) && (n = e + 8);
        let l;
        if (n) {
          for (let b3 = n; b3 < d3; b3++)
            if (!a(t[b3])) {
              l = b3;
              break;
            }
        }
        let i;
        if (l !== void 0 && t[l] === "m" ? i = l : l !== void 0 && t[l] === "}" && t[l + 1] === "m" && (i = l + 1), !i) {
          $2 = true;
          continue;
        }
        if (t[i + 1] === "$" && t[i + 2] === "{" && t[i + 3] === "`") {
          e = i + 3;
          continue;
        }
      }
      $2 = true;
    }
    if (!m2 && t[e].trim() && u2 && u2 <= e && (t[e] === "(" ? m2 = e : (u2 = null, s = null)), D2(o) && o.triggerKeywords && Array.isArray(o.triggerKeywords)) {
      let n;
      for (let l = 0, i = o.triggerKeywords.length; l < i; l++)
        if (t.startsWith(o.triggerKeywords[l], e)) {
          n = o.triggerKeywords[l];
          break;
        }
      if (n) {
        u2 = e + n.length, e = e + n.length - 1;
        continue;
      }
    }
  }
  return r = null, u2 = null, m2 = null, c2 = 1, $2 = void 0, s = null, c2 = 1, { log: { timeTakenInMilliseconds: Date.now() - p2 }, result: v(t, g2.current()), ranges: g2.current() };
}
// src/correct-row-num.ts
var create = (context) => {
  return {
    CallExpression(node) {
      if (node.callee && node.callee.type === "MemberExpression" && node.callee.object && node.callee.object.type === "Identifier" && node.callee.object.name === "console" && node.callee.property && node.callee.property.type === "Identifier" && node.callee.property.name === "log" && node.arguments && Array.isArray(node.arguments) && node.arguments.length) {
        node.arguments.forEach((arg) => {
          if (arg.type === "Literal" && typeof arg.raw === "string" && arg.raw !== j(arg.raw, {
            overrideRowNum: arg.loc.start.line,
            extractedLogContentsWereGiven: true
          }).result) {
            context.report({
              node,
              messageId: "correctRowNum",
              fix: (fixerObj) => {
                let { ranges } = j(arg.raw, {
                  overrideRowNum: arg.loc.start.line,
                  extractedLogContentsWereGiven: true
                });
                if (Array.isArray(ranges) && ranges.length) {
                  let offset = arg.start;
                  if (!offset && arg.range && typeof arg.range[0] === "number") {
                    offset = arg.range[0];
                  }
                  let preppedRanges = [
                    offset + ranges[0][0],
                    offset + ranges[0][1]
                  ];
                  return fixerObj.replaceTextRange(preppedRanges, ranges[0][2]);
                }
              }
            });
          } else if (arg.type === "TemplateLiteral" && Array.isArray(arg.quasis) && arg.quasis.length && typeof arg.quasis[0] === "object" && arg.quasis[0].value && arg.quasis[0].value.raw && arg.quasis[0].value.raw !== j(arg.quasis[0].value.raw, {
            overrideRowNum: arg.loc.start.line,
            extractedLogContentsWereGiven: true
          }).result) {
            context.report({
              node,
              messageId: "correctRowNum",
              fix: (fixerObj) => {
                let { ranges } = j(arg.quasis[0].value.raw, {
                  overrideRowNum: arg.loc.start.line,
                  extractedLogContentsWereGiven: true
                });
                if (ranges) {
                  let offset = arg.quasis[0].range[0] + 1;
                  if (!offset && arg.range && typeof arg.range[0] === "number") {
                    offset = arg.quasis[0].start + 1;
                  }
                  let preppedRanges = [
                    offset + ranges[0][0],
                    offset + ranges[0][1]
                  ];
                  return fixerObj.replaceTextRange(preppedRanges, ranges[0][2]);
                }
              }
            });
          }
        });
      }
    }
  };
};
var correctRowNum = {
  create,
  meta: {
    type: "suggestion",
    messages: {
      correctRowNum: "Update the row number."
    },
    fixable: "code"
  }
};
// src/main.ts
var main_default = {
  configs: {
    recommended: {
      plugins: ["row-num"],
      rules: {
        "no-console": "off",
        "row-num/correct-row-num": "error"
      }
    }
  },
  rules: {
    "correct-row-num": correctRowNum
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
/**
 * @name js-row-num
 * @fileoverview Update all row numbers in all console.logs in JS code
 * @version 6.0.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/js-row-num/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 6.2.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 8.2.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 6.2.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 5.1.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 6.1.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */

module.exports = __toCommonJS(main_default);
